/*
    SDL - Simple DirectMedia Layer
    Copyright (C) 1997-2004 Sam Lantinga

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Sam Lantinga
    slouken@libsdl.org
*/

#ifndef _SDL_epocAudio_h
#define _SDL_epocAudio_h

#ifdef SAVE_RCSID
static char rcsid =
 "@(#) $Id: SDL_epocAudio.h,v 1.4 2004/11/28 16:11:42 petrus Exp $";
#endif

#define NUM_BUFFERS 2         /* -- Don't lower this! */

/*------------------------------------------------------ class ServerSession -+
|                                                                             |
+----------------------------------------------------------------------------*/
class ServerSession : public RSessionBase
{
public:
   ServerSession(TInt & err);
   virtual ~ServerSession();
   TInt openAudio(SDL_AudioSpec * spec);
   void closeAudio();
   void waitAudio();
   unsigned char * getAudioBuf();
   int playAudio();
   void waitDone();

private:
   RSemaphore m_semBufferAvailable;
   int m_isCreated;
   int m_isOpen;
   int m_bufIndex;
   char * m_rawBuffers[NUM_BUFFERS];   /* audio fragments */

   int execute(TInt audioFunction, TAny * args);
};

#endif /* _SDL_epocAudio_h */
/*============================================================================*/
